function map = GridMapping(pose, scan, MaxLaserRange)
    global MyGridMap
    locc = -30;
    lfree = 3;
    % Update de la carte pour chaque rayon
    for index = 1:size(scan,2)
        if ~isnan(scan(2,index))
            % Scan valide
            xEnd = pose(1) + cos(scan(1,index)+pose(3))*scan(2,index);
            yEnd = pose(2) + sin(scan(1,index)+pose(3))*scan(2,index);
            xUpdate = round(xEnd); yUpdate = round(yEnd);
            if ( (xUpdate <= size(MyGridMap,2)) && (yUpdate <= size(MyGridMap,2)) && (xUpdate > 0) && (yUpdate > 0))
                MyGridMap(yUpdate,xUpdate) = MyGridMap(yUpdate,xUpdate) + locc;
            end
        end
        
        if isnan(scan(2,index))
            % we will have the maximum range as the endpoint, but no
            % obstacles.
            xEnd = pose(1) + cos(scan(1,index)+pose(3))*MaxLaserRange;
            yEnd = pose(2) + sin(scan(1,index)+pose(3))*MaxLaserRange;
            xUpdate = round(xEnd); yUpdate = round(yEnd);
        end
        
        % Get the empty space now
        [xFree yFree] = BresenhamLineArray(pose(1), xUpdate, pose(2),yUpdate);

        %update the grid locations
        for indexFree = 1:size(xFree,2)
            xUp = xFree(indexFree);
            yUp = yFree(indexFree);
            if ( (xUp <= size(MyGridMap,2)) && (yUp <= size(MyGridMap,2)) && (xUp > 0) && (yUp > 0))
                if ~((xUp == xUpdate) && (yUp == yUpdate)) % Because we don't want to update end of beam, which is obstacle.
                    MyGridMap(yUp,xUp) = MyGridMap(yUp,xUp) + lfree;
                end
            end              
        end
    end
    
    % hCurrentFigure = gcf; % On sauvegarde le handle de la figure en court
    %figure(2);
    subplot(2,2,4);
    imagesc((tanh(MyGridMap.*0.1)+1).*0.5); % To have a better visualization
    set(gca,'YDir','normal'); % just so coordinate won't be upside down.
    %axis equal
    colormap('gray'); caxis([0 1]);
    %drawnow()
    %figure(hCurrentFigure); % On restaure la figure en cours
end